﻿/******************
    Copyright 2013 - http://www.simonepomata.com
******************/
app.displayDialogs = DialogModes.ERROR;
var doc = app.activeDocument;
var livelli = doc.layers;
var selezionati =getSelectedLayersIdx();

var w = new Window('dialog', 'Maschere di Luminosità - SimonePomata.com', undefined, {closeButton: false});
var testo = w.add("panel");
testo.add ("statictext", undefined, "Questo script è stato creato da Simone Pomata.");
testo.add ("statictext", undefined, "Lo script può essere utilizzato, diffuso e modificato gratuitamente.");
testo.add ("statictext", undefined, "Vi chiedo solo di lasciare questo messaggio e se vi va di citare l'autore.");
testo.add ("statictext", undefined, "© - 2013 - www.SimonePomata.com");

w.add("statictext",undefined, "Scegli la maschera da utilizzare:");
var radioTipo  = w.add("group");
w.alignChildren = ['fill','fill'];
radioTipo.alignChildren = ['center','center'];
radioTipo.add ("radiobutton", undefined, "Luci");
radioTipo.add ("radiobutton", undefined, "Ombre");
radioTipo.add ("radiobutton", undefined, "Mezzitoni");
radioTipo.children[0].value = true;
w.add('panel');
w.add("statictext",undefined, "Scegli l'intensità della maschera:");
var intensita = w.add ("dropdownlist", undefined, ["Base","+","++","+++"]);
intensita.maximumSize.width = 100;
intensita.selection = 0;
w.add('panel');

var bottoni = w.add("group");
bottoni.alignChildren = ['center','center'];
var bottoneOk = bottoni.add('button', undefined, 'OK', );
var bottoneAnnulla =bottoni.add('button', undefined, 'Annulla', {name:'Cancel'});
bottoneOk.onClick = comincia;

//dopo il click su ok
function comincia(){
    var tipo = selected_rbutton(radioTipo);
    var fattore = intensita.selection.index;
    w.hide();
    var mascherati = 0;
    for(var i in selezionati){
        if( parseInt(activeDocument.activeLayer.bounds.toString().replace(/\D/g,"")) == 0 ){continue;} //se il livello è vuoto (trasparente)
        if(selezionati[i] != 0){
            seleziona(selezionati[i], true);
            var livello = app.activeDocument.activeLayer;
            if(livello.typename == 'ArtLayer' && livello.kind == 'LayerKind.NORMAL' && (!layerHasMask(livello)) && ( !livello.allLocked ) && ( !livello.isBackgroundLayer )){
            app.activeDocument.suspendHistory("Script Gamma Dinamica", "agisci(fattore, tipo)"); //crea  uno stato storia per ogni azione
                mascherati++;
            }
        }
    }
    var frase ="La funzione è stata completata. " + mascherati + " ";
    frase += (mascherati == 1) ? "livello è stato mascherato." : "livelli sono stati mascherati.";
    alert(frase);
}

function selected_rbutton (rbuttons){
    for (var i = 0; i < rbuttons.children.length; i++)
        if (rbuttons.children[i].value == true)
            return i;
}

//lavora sui canali
function agisci(fattore, tipo){
    var docRef = app.activeDocument;
    //sel tutto, copia
    var idsetd = charIDToTypeID( "setd" );
    var desc93 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
    var ref87 = new ActionReference();
    var idChnl = charIDToTypeID( "Chnl" );
    var idfsel = charIDToTypeID( "fsel" );
    ref87.putProperty( idChnl, idfsel );
    desc93.putReference( idnull, ref87 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idAl = charIDToTypeID( "Al  " );
    desc93.putEnumerated( idT, idOrdn, idAl );
    executeAction( idsetd, desc93, DialogModes.NO );
    var idcopy = charIDToTypeID( "copy" );
    executeAction( idcopy, undefined, DialogModes.NO );

    var nuovoCanale = docRef.channels.add();
 
    // incolla
    var idpast = charIDToTypeID( "past" );
    var desc112 = new ActionDescriptor();
    var idAntA = charIDToTypeID( "AntA" );
    var idAnnt = charIDToTypeID( "Annt" );
    var idAnno = charIDToTypeID( "Anno" );
    desc112.putEnumerated( idAntA, idAnnt, idAnno );
    executeAction( idpast, desc112, DialogModes.NO );
    docRef.selection.deselect();
    
   var numeroVolte = Math.pow(2,fattore);
 
   if(tipo == 0){ //luci
       var canaleLuci = selezioniProgressiveLuci(nuovoCanale, numeroVolte);
       canaleLuci.remove();
   }
   if(tipo == 1){ //ombre
       var canaleOmbre = selezioniProgressiveOmbre(nuovoCanale, numeroVolte);
       canaleOmbre.remove();
   }
   if(tipo == 2){ //mezzi
       var canaleLuci = selezioniProgressiveLuci(nuovoCanale, numeroVolte);
       var canaleOmbre = selezioniProgressiveOmbre(nuovoCanale, numeroVolte);
       mezziToni(canaleOmbre,canaleLuci);
       canaleLuci.remove();
       canaleOmbre.remove();
   }
   
    nuovoCanale.remove();
    makeMaskFromSelection();
}

//ricava gli id dei livelli selezionati
function getSelectedLayersIdx(){ 
      var selectedLayers = new Array; 
      var ref = new ActionReference(); 
      ref.putEnumerated( charIDToTypeID("Dcmn"), charIDToTypeID("Ordn"), charIDToTypeID("Trgt") ); 
      var desc = executeActionGet(ref); 
      if( desc.hasKey( stringIDToTypeID( 'targetLayers' ) ) ){ 
         desc = desc.getList( stringIDToTypeID( 'targetLayers' )); 
          var c = desc.count 
          var selectedLayers = new Array(); 
          for(var i=0;i<c;i++){ 
            try{ 
               activeDocument.backgroundLayer; 
               selectedLayers.push(  desc.getReference( i ).getIndex() ); 
            }catch(e){ 
               selectedLayers.push(  desc.getReference( i ).getIndex()+1 ); 
            } 
          } 
       }else{ 
         var ref = new ActionReference(); 
         ref.putProperty( charIDToTypeID("Prpr") , charIDToTypeID( "ItmI" )); 
         ref.putEnumerated( charIDToTypeID("Lyr "), charIDToTypeID("Ordn"), charIDToTypeID("Trgt") ); 
         try{ 
            activeDocument.backgroundLayer; 
            selectedLayers.push( executeActionGet(ref).getInteger(charIDToTypeID( "ItmI" ))-1); 
         }catch(e){ 
            selectedLayers.push( executeActionGet(ref).getInteger(charIDToTypeID( "ItmI" ))); 
         } 
      } 
      return selectedLayers; 
};
//seleziona livello in base all'id
function seleziona( idx, visible ){
   if( idx.constructor != Array ) idx = [ idx ];
   for( var i = 0; i < idx.length; i++ ){
      var desc = new ActionDescriptor();
      var ref = new ActionReference();
      ref.putIndex(charIDToTypeID( "Lyr " ), idx[i])
      desc.putReference( charIDToTypeID( "null" ), ref );
      if( i > 0 ) {
         var idselectionModifier = stringIDToTypeID( "selectionModifier" );
         var idselectionModifierType = stringIDToTypeID( "selectionModifierType" );
         var idaddToSelection = stringIDToTypeID( "addToSelection" );
         desc.putEnumerated( idselectionModifier, idselectionModifierType, idaddToSelection );
      }
      desc.putBoolean( charIDToTypeID( "MkVs" ), visible );
      executeAction( charIDToTypeID( "slct" ), desc, DialogModes.NO );
   }   
}
//controlla se il livello ha una maschera
function layerHasMask (tLayer) {
   try {
      selectLayerOrMask(tLayer.name,true);
//      var ac = activeDocument.activeChannels; // this yields an error
//      selectLayerOrMask(tLayer.name); // this does not change the selected channels
      return true;
   }
   catch (e) {return false;}
   function selectLayerOrMask (tLayer, mask) {
      var id95 = charIDToTypeID( "slct" );
      var desc20 = new ActionDescriptor();
      var id96 = charIDToTypeID( "null" );
      var ref17 = new ActionReference();
      if (mask == true){
         ref17.putEnumerated( charIDToTypeID( "Chnl" ), charIDToTypeID( "Chnl" ), charIDToTypeID( "Msk " ) );
      }
      var id100 = charIDToTypeID( "Lyr " );
      ref17.putName( id100, tLayer );
      desc20.putReference( id96, ref17 );
      var id101 = charIDToTypeID( "MkVs" );
      desc20.putBoolean( id101, false );
      executeAction( id95, desc20, DialogModes.NO );
   }
}
//crea maschera da seleziona
function makeMaskFromSelection(blHide){
   blHide ? blHide = "HdSl":blHide =  "RvlS";
    var desc = new ActionDescriptor();
    desc.putClass( charIDToTypeID( "Nw  " ), charIDToTypeID( "Chnl" ) );
        var ref = new ActionReference();
        ref.putEnumerated( charIDToTypeID( "Chnl" ), charIDToTypeID( "Chnl" ), charIDToTypeID( "Msk "  ));
    desc.putReference( charIDToTypeID( "At  " ), ref );
    desc.putEnumerated( charIDToTypeID( "Usng" ), charIDToTypeID( "UsrM" ), charIDToTypeID( "RvlS" ) );
     executeAction( charIDToTypeID( "Mk  " ), desc, DialogModes.NO );
}

function selezioniProgressiveOmbre(nuovoCanale, numero){
    doc.selection.load (nuovoCanale, SelectionType.REPLACE, true);   //carica e inverti  
    numero--;
    while(numero--){
        doc.selection.load (nuovoCanale, SelectionType.DIMINISH );    
    }
    var chanRef = doc.channels.add();
    doc.selection.store( chanRef, SelectionType.EXTEND );
    return chanRef;
}
function selezioniProgressiveLuci(nuovoCanale, numero){
    doc.selection.deselect(); 
    doc.selection.load (nuovoCanale, SelectionType.REPLACE ); //evitiamo finestra di dialogo facendo replace la prima volta   
    numero--;
    while(numero--){
        doc.selection.load (nuovoCanale, SelectionType.INTERSECT );    
    }
    var chanRef = doc.channels.add();
    doc.selection.store( chanRef, SelectionType.EXTEND );
    return chanRef;
}
function mezziToni(ombre, luci){
    doc.selection.selectAll(); 
    doc.selection.load (ombre, SelectionType.DIMINISH );    
    doc.selection.load (luci, SelectionType.DIMINISH );    
}

w.show();